******************************************
**  Joypad stuff                        **
******************************************

                .include "jaguar.inc"

                .globl  handle_input
                .globl  readpad
                .globl  fire
                .globl  fire2
                .globl  turn_left
                .globl  turn_right
                .globl  go_up
                .globl  go_down

turn_left:      .dc.w   0
turn_right:     .dc.w   0
go_up:          .dc.w   0
go_down:        .dc.w   0
thrust:         .dc.w   0
fire:           .dc.w   0
fire2:          .dc.w   0
firelock:       .dc.w   0
PAUSE_ON:       .dc.w   0
pawslock:       .dc.w   0
hyper:          .dc.w   0
cfirelock:      .dc.w   0
exit_flag:      .dc.w   0



;================================================================================================
handle_input:
        move.l  joycur,d0
ck_up:
        btst.l  #JOY_UP,d0
        beq.b   ck_down
        move.w #1,go_up
        move.w #0,go_down
        bra.b   ck_left
ck_down:
        move.w #0,go_up
        move.w #0,go_down
        btst.l  #JOY_DOWN,d0
;        btst.l  #FIRE_C,d0
        beq.b   ck_left
        move.w #1,go_down
ck_left:
        btst.l  #JOY_LEFT,d0
        beq.b   .1
                move.w  #1,turn_left
                bra     ck_right
.1:
                move.w  #0,turn_left
ck_right:
        btst.l  #JOY_RIGHT,d0
        beq.b   .2
                move.w  #1,turn_right
                bra.b   ck_joy_2player
.2:
                move.w  #0,turn_right
ck_joy_2player:

        move.l  joycur,d0
ck_fireA:
        btst.l  #FIRE_A,d0
        beq.b   .3
                move.w  #1,thrust
                move.w  #1,fire2
                bra     ck_fireB
.3:
                move.w  #0,thrust
                move.w  #0,fire2
ck_fireB:
        btst.l  #FIRE_B,d0
        beq.b   .4
        nop
        tst.w   firelock
        bne.s   ck_fireC
                move.w  #1,fire
                move.w  #1,firelock
                bra     ck_fireC
.4:
                move.w  #0,firelock
                move.w  #0,fire
ck_fireC:
        btst.l  #FIRE_C,d0
        beq.b   .5
        nop
        tst.w   firelock
        bne.s   ck_fireC
                move.w  #1,hyper
                move.w  #1,cfirelock
                bra     ck_Option
.5:
                move.w  #0,cfirelock
                move.w  #0,hyper
ck_Option:
        btst.l  #OPTION,d0
        beq.b   ck_Pause
        nop
ck_Pause:
        btst.l  #PAUSE,d0
        beq.b   .6
        tst.w   pawslock
        bne.s   fire_done
                eor.w   #1,PAUSE_ON
                move.w  #1,pawslock
                bra     fire_done
.6:
                move.w  #0,pawslock
fire_done:
        and.l   #ANY_FIRE,d0
        bne     ck_fire_2player

;------------------------------
; No firebuttons were pressed
        nop

ck_fire_2player:

;------------------------------------------------------------------------------------------------
ck_keypad:
;--------------------------------------------------------------
;  Evaluate each 12-key button from the keypad and execute
;  code independent to each button.
;--------------------------------------------------------------
;       lea     keys1,a1
        move.l  joycur,d0               ; necessary to perform following modulo 32 BTST
ck_key1:
        btst.l  #KEY_1,d0
        beq.b   ck_key2
        nop
ck_key2:
        btst.l  #KEY_2,d0
        beq.b   ck_key3
        nop
ck_key3:
        btst.l  #KEY_3,d0
        beq.b   ck_key4
        nop
ck_key4:
        btst.l  #KEY_4,d0
        beq.b   ck_key5
        nop
ck_key5:
        btst.l  #KEY_5,d0
        beq.b   ck_key6
        nop
ck_key6:
        btst.l  #KEY_6,d0
        beq.b   ck_key7
        nop
ck_key7:
        btst.l  #KEY_7,d0
        beq.b   ck_key8
        nop
ck_key8:
        btst.l  #KEY_8,d0
        beq.b   ck_key9
        nop
ck_key9:
        btst.l  #KEY_9,d0
        beq.b   ck_keyS
        nop
ck_keyS:
        btst.l  #KEY_STAR,d0
        beq.b   ck_key0
        btst.l  #KEY_HASH,d0
        beq.b   ck_key0
        move.w  #1,exit_flag
ck_key0:
        btst.l  #KEY_0,d0
        beq.b   ck_keyH
        nop
ck_keyH:
        btst.l  #KEY_HASH,d0
        beq.b   keypad_done
        nop
keypad_done:
        and.l   #ANY_KEY,d0
        bne     ck_key_2player
;----------------------------------------
; No buttons on the keypad were pressed
        nop

ck_key_2player:

hi_end:                                  ; handle input end
        rts

;================================================================================================
readpad:
;scan for player 1
        move.l  #$f0fffffc,d1           ; d1 = Joypad data mask
        moveq.l #-1,d2                  ; d2 = Cumulative joypad reading

        move.w  #$81fe,JOYSTICK
        move.l  JOYSTICK,d0             ; Read joypad,pause button,A button
        or.l    d1,d0                   ; Mask off unused bits
        ror.l   #4,d0
        and.l   d0,d2                   ; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
        move.w  #$81fd,JOYSTICK
        move.l  JOYSTICK,d0             ; Read *741 keys,B button
        or.l    d1,d0                   ; Mask off unused bits
        ror.l   #8,d0
        and.l   d0,d2                   ; d2 = xxAPxxBx RLDU741* xxxxxxxx xxxxxxxx
        move.w  #$81fb,JOYSTICK
        move.l  JOYSTICK,d0             ; Read 2580 keys,C button
        or.l    d1,d0                   ; Mask off unused bits
        rol.l   #6,d0
        rol.l   #6,d0
        and.l   d0,d2                   ; d2 = xxAPxxBx RLDU741* xxCxxxxx 2580xxxx
        move.w  #$81f7,JOYSTICK
        move.l  JOYSTICK,d0             ; Read 369# keys,Option button
        or.l    d1,d0                   ; Mask off unused bits
        rol.l   #8,d0
        and.l   d0,d2                   ; d2 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== inputs active low

        moveq.l #-1,d1
        eor.l   d2,d1                   ; d1 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high

        move.l  joycur,d0               ; old joycur needed for determining the new joyedge
        move.l  joycur,d2               ; old joycur needed for determining the new joyedge
        and.l   #$00f00000,d2
        move.l  d1,joycur               ; Current joypad reading stored into joycur
        eor.l   d1,d0
        and.l   d1,d0
        or.l    d2,d0
        move.l  d0,joyedge              ;joypad,buttons,keys that were just pressed

;scan for player 2
        move.l  #$0ffffff3,d1           ; d1 = Joypad data mask
        moveq.l #-1,d2                  ; d2 = Cumulative joypad reading

        move.w  #$817f,JOYSTICK
        move.l  JOYSTICK,d0             ; Read joypad,pause button,A button
        or.l    d1,d0                   ; Mask off unused bits
        rol.b   #2,d0                   ; note the size of rol
        ror.l   #8,d0
        and.l   d0,d2                   ; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
        move.w  #$81bf,JOYSTICK
        move.l  JOYSTICK,d0             ; Read *741 keys,B button
        or.l    d1,d0                   ; Mask off unused bits
        rol.b   #2,d0                   ; note the size of rol
        ror.l   #8,d0
        ror.l   #4,d0
        and.l   d0,d2                   ; d2 = xxAPxxBx RLDU741* xxxxxxxx xxxxxxxx
        move.w  #$81df,JOYSTICK
        move.l  JOYSTICK,d0             ; Read 2580 keys,C button
        or.l    d1,d0                   ; Mask off unused bits
        rol.b   #2,d0                   ; note the size of rol
        rol.l   #8,d0
        and.l   d0,d2                   ; d2 = xxAPxxBx RLDU741* xxCxxxxx 2580xxxx
        move.w  #$81ef,JOYSTICK
        move.l  JOYSTICK,d0             ; Read 369# keys,Option button
        or.l    d1,d0                   ; Mask off unused bits
        rol.b   #2,d0                   ; note the size of rol
        rol.l   #4,d0
        and.l   d0,d2                   ; d2 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== inputs active low

        moveq.l #-1,d1
        eor.l   d2,d1                   ; d1 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high

        move.l  joycur+4,d0             ; old joycur needed for determining the new joyedge
        move.l  joycur+4,d2             ; old joycur needed for determining the new joyedge
        and.l   #$00f00000,d2
        move.l  d1,joycur+4             ; Current joypad reading stored into joycur
        eor.l   d1,d0
        and.l   d1,d0
        or.l    d2,d0
        move.l  d0,joyedge+4            ;joypad,buttons,keys that were just pressed

        rts


joyedge:         dc.l            0,0
joycur:          dc.l            0,0
